LeetCodere热题100 最小覆盖子串

题目描述

给定两个字符串 s 和 t,长度分别是 m 和 n,返回 s 中的 最短窗口 子串,使得该子串包含 t 中的每一个字符(包括重复字符)。如果没有这样的子串,返回空字符串 ""。

测试用例保证答案唯一。

示例 1:

输入: s = "ADOBECODEBANC", t = "ABC"
输出: "BANC"
解释: 最小覆盖子串 "BANC" 包含来自字符串 t 的 'A'、'B' 和 'C'。

示例 2:

输入: s = "a", t = "a"
输出: "a"
解释: 整个字符串 s 是最小覆盖子串。

示例 3:

输入: s = "a", t = "aa"
输出: ""
解释: t 中两个字符 'a' 均应包含在 s 的子串中,

因此没有符合条件的子字符串,返回空字符串。

提示:

m == s.length

n == t.length
1<=m,n<=1051 <= m, n <= 10^51<=m,n<=105

s 和 t 由英文字母组成

思路

1 用一个桶装t字符串的个数,同时记录全部的个数res。

2 利用滑动窗口的思想,每次遇到一个是t中的字符,res减1,当res=0时,证明这个字符串是可行的。

3 多次判断求最小的字符串即可。

代码

cpp 复制代码
class Solution {
public:
    string minWindow(string s, string t) {
        vector<int>num(256, 0);
		int ss = s.size(), ts = t.size();
        for(int i = 0; i < ts; ++i)
        {
        	++num[t[i]];
		}
		int l = 0;
		int res = ts, ansl = -1, ansr = 1e9;
		for(int r = 0; r < ss; ++r)
		{
			if(--num[s[r]] >= 0)
			{
				if(--res == 0)
				{
					while(l < ss && ++num[s[l++]] <= 0);
					++res;
					// 范围是l - 1 ~ r;
					if(r - l + 1 < ansr - ansl)
					{
						ansl = l - 1;
						ansr = r;	
					} 
				}
			}
		}
		if(ansl == -1)
		{
			return "";
		}
		else
		{
			return s.substr(ansl, ansr - ansl + 1);
		}
    }
};
相关推荐
一去不复返的通信er2 小时前
力扣-图论-岛屿数量
算法·leetcode·图论
程序 代码狂人5 小时前
切片表与分区表的区别(数据开发面试版)
java·大数据·开发语言·数据仓库·算法
HDU-Dade6 小时前
【校招笔试真题】简要介绍 Self-Attention 的前沿算法
人工智能·算法
Xin7706 小时前
LeetCode 79. 单词搜索(DFS 回溯法)
leetcode
小郎君6588 小时前
Vue keep-alive 切标签后滚动位置回顶?因为 onDeactivated 里读到的 scrollTop 是 0
算法
邵奈一8 小时前
GPT-6.1 Terra速度是Sol的3倍,价格减半
算法
RaaS1008 小时前
Node.js Brotli RCE 漏洞自查指南:fetch、undici、axios 都在影响面,三分钟确认你的版本
人工智能·深度学习·算法
shehuiyuelaiyuehao8 小时前
算法56,重排链表
数据结构·算法·链表
qq_452396239 小时前
第四篇:《索引原理与实战:B-tree、Hash、GIN、GiST、BRIN》
算法·哈希算法·gin